#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "uart.h"
#include "pollin.h"
#include "rf12.h"
#include "spi.h"



int main(void) {
	//UART_init();
 	//setupPollinBoard();
	
	// Pollin-Board Hardware vorbereiten
	DDRD = (1<<LED1) | (1<<LED2); // Port D: Ausgang für LED1 und LED2, Rest Eingang	
	LED_AN(LED1);
	
	UART_init();

	//PORTB &= ~(1<<CS);		// Slave Select an (Active-Low)
	
	UART_puts("Initialisiere RF12\r\n");
	rf12_init();
	UART_puts("Setze Frequenz auf 433.27MHz\r\n");
	rf12_setfreq(RF12FREQ(433.27));	// Sende/Empfangsfrequenz auf 433,27MHz einstellen
	UART_puts("Setze Bandbreite auf 200kHz\r\n");
	rf12_setbandwidth(4, 1, 4);		// 200kHz Bandbreite, -6dB Verstärkung, DRSSI threshold: -79dBm 
	UART_puts("Setze Geschwindigkeit 19200baud\r\n");
	rf12_setbaud(19200);			// 19200 baud
	UART_puts("Setze 1mW Ausgangangsleistung, 120kHz Frequenzshift\r\n");
	rf12_setpower(0, 6);			// 1mW Ausgangangsleistung, 120kHz Frequenzshift
	
	
	LED_AUS(LED1);
	LED_AUS(LED2);
	_delay_ms(500);
	UART_puts("Enable RX Circuitry\r\n");
	rf12_rxenable();
	UART_puts("Warte auf Daten\r\n");
	while(1){
		int i=0;
		while(i<=40) {
			if (PIND & (1<<PIND3)){
				i++;
				int wert= (int) rf12_rxbyte();
				char puffer[5];
				itoa(wert,puffer,16);
				if (puffer[1]==0) {
					puffer[2]=0;
					puffer[1]=puffer[0];
					puffer[0]='0';
				}
				UART_puts(puffer);
				UART_putchar(' ');
				
				LED_AN(LED1);
				LED_AUS(LED2);
			} else {
				LED_AN(LED2);
				LED_AUS(LED1);
			}
			
		}
		UART_puts("\r\nNL:");
	}
}

