#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "uart.h"
#include "pollin.h"
#include "rf12.h"
 


void send(void);

int main(void) {
	// Pollin-Board Hardware vorbereiten
	DDRD = (1<<LED1) | (1<<LED2); // Port D: Ausgang für LED1 und LED2, Rest Eingang	
	LED_AN(LED1);
	
	UART_init();

	//PORTB &= ~(1<<CS);		// Slave Select an (Active-Low)
	
	UART_puts("Initialisiere RF12\r\n");
	rf12_init();
	UART_puts("Setze Frequenz auf 433.27MHz\r\n");
	rf12_setfreq(RF12FREQ(433.27));	// Sende/Empfangsfrequenz auf 433,27MHz einstellen
	UART_puts("Setze Bandbreite auf 200kHz\r\n");
	rf12_setbandwidth(4, 1, 4);		// 200kHz Bandbreite, -6dB Verstärkung, DRSSI threshold: -79dBm 
	UART_puts("Setze Geschwindigkeit 19200baud\r\n");
	rf12_setbaud(19200);			// 19200 baud
	UART_puts("Setze 1mW Ausgangangsleistung, 120kHz Frequenzshift\r\n");
	rf12_setpower(0, 6);			// 1mW Ausgangangsleistung, 120kHz Frequenzshift

	for (;;)
	{
		LED_AUS(LED2);
		LED_AN(LED1);
		//for (unsigned char i=0; i<10; i++)
		send();
		LED_AUS(LED1);
		LED_AN(LED2);
		for (unsigned char i=0; i<100; i++)
			_delay_ms(10);
		
	}
}

void send(void)
{	
	unsigned char test[]="ZZZZZZZZZZ";	
	rf12_txdata(test,10);
}

